<?php
/*
Plugin Name: AEIOU - Advanced Export/Import (WordPress) Object Users
Plugin URI: http://wordpress.org/extend/plugins/aeiou/
Description: AEIOU is a powerfull plugin that export all wordpress users info into an XML file including user metadatas and allow to import the same xml file into a new wordpress keeping the metadata of each user. 
Author: toSend.it di Luisa Marra
Version: 0.1
Author URI: http://tosend.it
*/

if(!class_exists('AEIOU')){
	class AEIOU{
		const VERSION = '0.1';
		const LANG_DOMAIN = 'AEIOU';
		
		public function __construct(){
			add_action('admin_init', array($this , 'init'));
			add_action('admin_menu', array($this, 'createPages'));
			#add_action('request', array($this, 'exportData'));
		}

		public function init(){
			load_plugin_textdomain(self::LANG_DOMAIN, false, basename(dirname( __FILE__ )).'/languages/' );
			if(isset($_GET['aeiou']) && $_GET['aeiou'] == 'export'){
				$this->exportData();
			}
		}
		
		private function toXMLItem($user){
			echo("\t<user base_id=\"{$user->ID}\">\n");
				echo("\t\t<user_login><![CDATA[{$user->user_login}]]></user_login>\n");
				/*
				 * I should export Password too (as requested by user)
				*/
				if(isset($_GET['pwd'])) echo("<user_pass><![CDATA[{$user->user_pass}]]></user_pass>\n");
				
				echo("\t\t<user_nicename><![CDATA[{$user->user_nicename}]]></user_nicename>\n");
				echo("\t\t<user_email><![CDATA[{$user->user_email}]]></user_email>\n");
				echo("\t\t<user_url><![CDATA[{$user->user_url}]]></user_url>\n");
				echo("\t\t<user_registered><![CDATA[{$user->user_registered}]]></user_registered>\n");
				echo("\t\t<user_activation_key><![CDATA[{$user->user_activation_key}]]></user_activation_key>\n");
				echo("\t\t<user_status><![CDATA[{$user->user_status}]]></user_status>\n");
				echo("\t\t<display_name><![CDATA[{$user->display_name}]]></display_name>\n");
				
				if(isset($_GET['metadata'])){
					/*
					 * I should export metadata (as requested by user)
					*/
					echo("\t\t<metadata>");
						
					$umeta = get_user_meta($user->ID);
					foreach($umeta as $key => $value){
							
						echo("\t\t\t<meta key=\"$key\"><![CDATA[");
						$value = $value[0];
						echo base64_encode($value); 
						echo("]]></meta>\n");
						
					}
						
					echo("\t\t</metadata>");
				}
				
			echo("\t</user>\n\n");
		}
		
		public function exportData(){
			if(isset($_GET['aeiou']) && $_GET['aeiou'] == 'export'){
				$u = new WP_User_Query(array('fields' => 'all'));
				$users = $u->get_results();
				/*
				 * Make the XML but ensure it will be downloaded
				*/
				header("Cache-Control: public");
				header("Content-Description: File Transfer");
				header('Content-type: application/xml; encoding=utf-8');
				header("Content-Disposition: attachment; filename=aeiou_users.xml");
				header("Content-Transfer-Encoding: binary");
				
				echo("<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n");
				echo("<!-- Export made with Wordpress AEIOU by toSend.it di Luisa Marra (http://tosend.it/) -->\n\n");
				
				echo("<users version=\"". self::VERSION . "\">\n");
				
				foreach($users as $user){
						
					echo $this->toXMLItem($user);
						
				}
				echo("</users>");
				exit();
			}
		}
		
		
		public function createPages(){
			add_users_page("AEIOU - Panel", 'AEIOU', 'add_users', 'aeiou', array($this, 'thePage'));
			
		}
		
		
		public function thePage(){
			global $wpdb;
			$screen = WP_Screen::get();
			
			add_meta_box('div-export-options-' .$screen->id, __('Export Users', self::LANG_DOMAIN),  array($this,'addExportMetabox'), 	$screen, 'normal',	'high');
			add_meta_box('div-import-options' . $screen->id, __('Import Users', self::LANG_DOMAIN),  array($this,'addImportMetabox'),  	$screen, 'normal', 	'high');

			wp_enqueue_script('post');
			add_screen_option('layout_columns', array('max' => 1, 'default' => 1) );
			global $wp_meta_boxes;
			?>
			<div class="wrap">
				<h2><?php _e('AEIOU - Panel', self::LANG_DOMAIN) ?></h2>
				<h3><?php _e('Advanced Export/Import (WordPress) Object Users', self::LANG_DOMAIN) ?></h3>
				<div id="poststuff">
					<div id="post-body" class="metabox-holder columns-<?php echo 1 == get_current_screen()->get_columns() ? '1' : '2'; ?>">
						<div id="postbox-container-1" class="postbox-container">
							<h2><?php _e('AEIOU is free!', self::LANG_DOMAIN); ?></h2>
							<p>
								<?php _e('If this plugin is useful to your purpose, please <strong>consider a donation</strong>. ', self::LANG_DOMAIN); ?>
								<?php echo sprintf(
									__('We\'re not asking you for <a href="%s">a lunch</a>.', self::LANG_DOMAIN),
								 	'https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@tosend.it&item_name=Donation%20for%20AEIOU&item_number=1&amount=30%2e00&currency_code=EUR'	
								); 
								?>
							</p>
							<p>
								<?php 
								$u = new WP_User_Query(array('fields' => 'all'));
								$userCount = $u->get_total() * 10;
								$amt = intval($userCount / 100);
								$dec = "00".($userCount % 100);
								$dec = substr($dec, -2);
								?>
								<?php _e('Feel free to donate as much as you want.', self::LANG_DOMAIN); ?>
								<?php echo sprintf(
									__('We think that <strong><a href="%s">0,10 € (euro) per user</a></strong> could be the right ammount.', self::LANG_DOMAIN),
									"https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@tosend.it&item_name=Donation%20for%20AEIOU&item_number=1&amount=$amt%2e$dec&currency_code=EUR") ;
								?>
							</p>
							<h2><?php _e('Premium support', self::LANG_DOMAIN);?></h2>
							<p>
								<?php _e('We are available for a premium support. If you need you can <a href="info@tosend.it">contact us</a> for a consulting.', self::LANG_DOMAIN)?>
							</p>
							<h2><?php _e('Translate AEIOU', self::LANG_DOMAIN)?></h2>
							<p>
								<?php _e('We would like to translate AEIOU in all languages, but we have not knowledge in more than Italian and... a little bit of English. So if you want contribute with your transaltion don\'t hesitate, send us and we will put into the next release!', self::LANG_DOMAIN); ?>
							</p>
							<p>
								<?php _e('This transaltion was made by:', self::LANG_DOMAIN); ?>
								<strong> 
									<a href="<?php _e('http://tosend.it', self::LANG_DOMAIN)?>"><?php _e('Luisa Marra', self::LANG_DOMAIN)?></a> 
								</strong>
							</p>
							<h2><?php _e('How to?', self::LANG_DOMAIN)?></h2>
							<p>
								<?php echo sprintf(__('Need some help? You can use the <a href="%s">WordPress support forum</a> for this plugin.', self::LANG_DOMAIN), 'http://wordpress.org/support/plugin/aeiou'); ?>
							</p>
						</div>
						<div id="postbox-container-2" class="postbox-container">
							<?php do_meta_boxes($screen, 'normal', $screen); ?>
						</div>
					</div>
				</div>
			</div>
			<?php 
		}

		
		public function addExportMetabox(){
			?>
			<form method="get" action="">
				<div>
					<input type="hidden" name="page" value="aeiou" />
					<input type="hidden" name="aeiou" value="export" />
					
					<input type="checkbox" name="pwd" id="aeiou_pwd" />
					<label for="aeiou_pwd"><?php _e('Export password fields too', self::LANG_DOMAIN) ?></label>
					
					<p class="help">
						<?php _e('Remeber that the password would be valid in the new website only if you keep the following defined constants:', self::LANG_DOMAIN); ?>
						<code>AUTH_KEY</code>, <code>SECURE_AUTH_KEY</code> <?php _e('and', self::LANG_DOMAIN); ?> <code>LOGGED_IN_KEY</code>.
					</p>
				</div>
				<div>
					<input type="checkbox" name="metadata" id="aeiou_md" />
					<label for="aeiou_md"><?php _e('Export users metadata', self::LANG_DOMAIN) ?></label>
				</div>
				<p>
				
					<input type="submit" class="primary" value="<?php _e("Export users", self::LANG_DOMAIN); ?>" />
				</p>
			</form>
			<?php 
		}
		
		
		private function decodeFileError($errorCode){
			
		}
		
		public function addImportMetabox(){

			?>
			<form method="post" action="?page=aeiou&aeiou=import" enctype="multipart/form-data">
				<div>
					<p>
						<strong><?php _e('If user exists (<em>found with the same username</em>):', self::LANG_DOMAIN)?></strong>
					</p>
					<p>
						<input type="radio" name="exists" id="aeiou_skip" value="skip" />
						<label for="aeiou_skip"><?php _e('Skip user if exists', self::LANG_DOMAIN) ?></label>
					</p>
					<p class="help">
						<?php _e( "it will be skipped and neither user data nor metadata will be imported", self::LANG_DOMAIN )?>
					</p>
					<p>
						<input type="radio" name="exists" id="aeiou_replace" value="replace" />
						<label for="aeiou_replace"><?php _e('Replace user if exists', self::LANG_DOMAIN) ?></label>
					</p>
					<p class="help">
						<?php _e( "it will be removed and imported as new user", self::LANG_DOMAIN )?>
					</p>
					<p>
						<input type="radio" name="exists" id="aeiou_update" value="update" />
						<label for="aeiou_update"><?php _e('Update only empty fields', self::LANG_DOMAIN) ?></label><br />
					</p>
					<p class="help">
						<?php _e( "the import will uppdate only the data and metadata that are empty", self::LANG_DOMAIN )?>
					</p>
					
				</div>
				<hr />
				<p>
					<input type="checkbox" name="metadata" id="aeiou_mdi" />
					<label for="aeiou_mdi"><?php _e('Import users metadata', self::LANG_DOMAIN); ?></label>
				</p>
				<p>
					<input type="checkbox" name="verbose" id="aeiou_verb" />
					<label for="aeiou_verb"><?php _e('Verbose output', self::LANG_DOMAIN); ?></label>
				</p>
				<hr />
				<p>
					<label for="the_file"><?php _e('The XML AEIOU User file:')?></label>
					<input type="file" name="the_file" id="the_file" />
				</p>
				<p>
					<input type="submit" class="primary" value="<?php _e("Import users", self::LANG_DOMAIN); ?>" />
				</p>
			</form>
			<pre class="output"><?php 
			
				
			
				if(isset($_GET['aeiou']) && $_GET['aeiou'] =='import'){
					/*
					 * Import requested
					 */
					require dirname(__FILE__) . '/parsers.php';
					
					if(isset($_FILES) && isset($_FILES['the_file'])){
						/*
						 * The request is correct
						 */					
						$theFile = $_FILES['the_file'];
						
						$verbose = isset($_POST['verbose']);
						
						if($theFile['error'] != 0){
							/*
							 * Some errors occours
							 */
							echo $this->decodeFileError($theFile['error']);
						}else{
							/*
							 * Starting import
							 */
							_e('Import started.', self::LANG_DOMAIN); echo "\n\n";
							_e('Please do not refresh the page and not go anywhere.'); echo "\n";
							_e('Interruption of page execution could cause data loss and user table to break!'); echo "\n"; 
							$parser = new AEIOU_Parser_SimpleXML();
							$users = $parser->parse($theFile['tmp_name']);
							
							$exists = isset($_POST['exists'])?$_POST['exists']:'skip';
							
							foreach($users as $user){
								$login = $user['user_login'];
								echo("\n<strong>$login</strong> ");
								$usr = get_user_by('login', $login);
								
								$userID = 0;
								
								$userMeta = (isset($user['metadata'])) ? $user['metadata'] : array();
								if(isset($user['metadata'])) unset($user['metadata']);
								
								if($usr && $exists != 'skip'){
									$usr = (array) $usr->data;
									
									if($exists == 'update'){
										
										/*
										 * Keeping metadata and removing from array
										 */
										
										foreach($user as $key => $value){
											/*
											 * Removing all non empty key from import
											 */
											if(isset($usr[$key]) && !empty($usr[$key])){
												unset($user[$key]);
											}
										}
									}
									
									if(count($user)>0){
										$changes = array_keys($user);
										$changes = "<code>".implode("</code>,<code>", $changes)."</code>";
										
										echo sprintf(__("has new %s value(s).", self::LANG_DOMAIN),$changes) . "\n";
										$user['ID'] = $usr['ID'];
										wp_update_user($user);
									}else{
										_e("unchanged.", self::LANG_DOMAIN) . "\n";
									}
									$userID = $user['ID'];
									
								}else{
								
									if(!$usr){
										/*
										 * New User must be created
										 */
										$userID = wp_insert_user($user);
										$user['ID'] = $userID;
										wp_update_user($user);
										echo sprintf(__("inserted with ID %d", self::LANG_DOMAIN),$userID) . "\n";
									}else{
										echo __("skipped due it's already in the database", self::LANG_DOMAIN) . "\n";
									}
										
								}
								if(isset($_POST['metadata']) && $userID != 0){
									
									/*
									 * Admin asked for metadata import
									*/

									$count = 0;
									foreach($userMeta as $key => $value){
										$metaKey = get_user_meta($userID, $key);
										
										if(empty($metaKey[0])) $metaKey = false;
										if(is_serialized($value)) $value = unserialize($value);
										if(!$metaKey || $exists=='replace'){
											delete_user_meta($userID, $key);
											if( !empty( $value ) ){

												$count+=1;
												if($verbose) echo sprintf(__("Metadata <code>%s</code> updated for user <strong>%s</strong>", self::LANG_DOMAIN), $key, $login) . "\n";

												
												update_user_meta($userID, $key, $value );
											}else{
												if($metaKey && $verbose) echo sprintf(__("Metadata <code>%s</code> removed for user <strong>%s</strong>", self::LANG_DOMAIN), $key, $login) . "\n";
											}
										}
									}
									if($count>0)
										echo sprintf(__("Updated %d metadatas for user <strong>%s</strong>", self::LANG_DOMAIN), $count, $login) . "\n";
									
								}
								
							}
							
						}
					}
				}
				?>
			</pre>
			<?php 
		}
	}
	
	$aeiou = new AEIOU();
		
	
}	
?>